#!/bin/sh

TMPD=/tmp/di-rbit$$
CFG_SEPARATOP="build/pkg-lists/"
BOOT_SPLASH="astra_boot.png"
MENU_CFG="menu.cfg"
POSTFIX=astra3

# cfg_remove() {
# find $1 -name "*cfg" | xargs -n 1 sed -i -e "/$2/d"
# }

cfg_subst() {
find $1 -name "*cfg" -type f | xargs -n 1 sed -i -e "/$2/s/$2/$3/g"
}

#cfg_append() {
#find $1 -name "*cfg" | xargs -n 1 sed -i -e "/$2/a$3"
#}

#if [ $UID == 0 ] || [ $EUID == 0 ]; then
#	echo "Не запускайте этот скрипт с правами суперпользователя,"
#	echo "это слишком опасно"
#	exit 0
#fi

if [ "$#" != 2 ]; then
	echo "Скрипт принимает два параметра:"
	echo "путь к папке с распакованными исходными кодами"
	echo "пакетов debian-installer из Убунты, и debian-installer из Дебьяна"
	exit 0
fi

if [ ! -f $BOOT_SPLASH ]; then
	echo "Скрипт не может найти в текущей папке файл $BOOT_SPLASH"
	exit 0
fi

ubuntu_di_path=$1
debian_di_path=$2

mkdir $TMPD
if [ $? != 0 ]; then
	echo "Не могу создать временную рабочую папку $TMPD"	
	exit 1
fi

filter_cfgs()
{
	dir_prefix=`find $1 -name "*cfg" -type f | grep pkg-list | awk -F"$CFG_SEPARATOP" '{ print $1 }' | tail -n1`
	cfg_list=`find $1 -name "*cfg" -type f | grep pkg-list | awk -F"$CFG_SEPARATOP" '{ print $2 }'` 

	# Copy all cfg files from di src packet to the tmp dir
	pushd $dir_prefix > /dev/null
		for tmp in $cfg_list; do
			install -D $CFG_SEPARATOP$tmp $TMPD/$2/$tmp
		done
	popd > /dev/null
	 
	# Leave only modules and firmware lines in the cfg files
	pushd $TMPD/$2 > /dev/null
		for tmp in $cfg_list; do
			sed -i -e '/-modules-/b' -e '/-firmware/b' -e d $tmp
		done
	popd > /dev/null
}

filter_cfgs $ubuntu_di_path ubuntu
filter_cfgs $debian_di_path debian

lists_operations()
{
target=$1; base=$2; sample=$3; op=$4
pushd $TMPD/$base > /dev/null
	cp -a ../$base ../$target	# To make directory structure
	for i in `find ./ -type f`; do
		if [ -f ../$sample/$i ]; then
			cat ../$sample/$i $i | sort | uniq $op > ../$target/$i
		else
			echo > ../$target/$i
		fi
	done
popd > /dev/null
}

lists_operations common      debian ubuntu "-d" # get common files
lists_operations debian-only debian common "-u" # get debian-only files
lists_operations ubuntu-only ubuntu common "-u" # get ubuntu-only files

# Make *rusbit from the debian-installer directory
deb_dir_prefix=`find $debian_di_path -name "*cfg" -type f| grep pkg-list | awk -F"$CFG_SEPARATOP" '{ print $1 }' | tail -n1`
deb_dir_lastdir=`cd $deb_dir_prefix; pwd | rev | awk -F/ '{ print $1 }' | rev`
pushd `pwd` > /dev/null
	cd $deb_dir_prefix/..
	if [ -d ${deb_dir_lastdir}-$POSTFIX ]; then
		rm -rf ${deb_dir_lastdir}-$POSTFIX
	fi
	cp -a $deb_dir_lastdir ${deb_dir_lastdir}-$POSTFIX
popd > /dev/null

rbit_dir_prefix=$deb_dir_prefix/../${deb_dir_lastdir}-$POSTFIX

# Remove debian-only modules from the -rbit version
pushd $rbit_dir_prefix/$CFG_SEPARATOP > /dev/null
	pushd $TMPD/debian-only > /dev/null
		debian_only_list=`find ./ -type f -name "*cfg"`
	popd > /dev/null
	for fname in $debian_only_list; do
		for str in `cat $TMPD/debian-only/$fname`; do
			sed -i -e "/$str/d" $fname
		done
	done
popd > /dev/null

# Add ubunty-only modules to the -rbit version
pushd $rbit_dir_prefix/$CFG_SEPARATOP > /dev/null
	pushd $TMPD/ubuntu-only > /dev/null
		ubuntu_only_list=`find ./ -type f -name "*cfg"`
	popd > /dev/null
	for fname in $ubuntu_only_list; do
		cat $TMPD/ubuntu-only/$fname >> $fname
	done
popd > /dev/null

# Make dynamic kernel version for the AMD64 build 
sed -e '/^install: build/a\\tsed -i -e "s/^KERNELVERSION.*/KERNELVERSION = $$kver/g" build/config/i386.cfg' -i $rbit_dir_prefix/debian/rules
sed -e '/^install: build/a\\tsed -i -e "s/^KERNELVERSION.*/KERNELVERSION = $$kver/g" build/config/amd64.cfg ; \\\\' -i $rbit_dir_prefix/debian/rules
sed -e "/^install: build/a\\\tkver=\`apt-cache search \"^linux-image-2.6\\\\..*generic\" | tail -n1 | awk '{ a = sub(\"linux-image-\", \"\", \$\$1); print \$\$a }'\` ; \\\\" -i $rbit_dir_prefix/debian/rules

# Fix apt-get parameters to force work with unauthenticated files
sed -i -e "/^APT_GET=/a	--force-yes \\\\" $rbit_dir_prefix/build/util/get-packages

# Fix release name
sed -i -e "s/lenny/orel/g" $rbit_dir_prefix/debian/rules
sed -i -e "s/lenny/orel/g" $rbit_dir_prefix/build/config/common

# Change vga boot mode for text install
sed -i -e "s/vga=normal/vga=771/g" $rbit_dir_prefix/build/config/i386.cfg
sed -i -e "s/vga=normal/vga=771/g" $rbit_dir_prefix/build/config/amd64.cfg

# Substitute boot image
rm $rbit_dir_prefix/build/boot/x86/pics/*
cp $BOOT_SPLASH $rbit_dir_prefix/build/boot/x86/pics/
sed -i -e "s/^SPLASH_PNG=.*/SPLASH_PNG=boot\/x86\/pics\/$BOOT_SPLASH/g" $rbit_dir_prefix/build/config/x86.cfg

# Substitute some other packages; version dependent
#cfg_subst $rbit_dir_prefix console-keymaps-at console-setup-pc-ekmap

echo Adding some needed udebs to the images
echo astra-license >> $rbit_dir_prefix/build/pkg-lists/base
echo astra-help-udeb >> $rbit_dir_prefix/build/pkg-lists/base

# Remove file with wrong packages sources
rm $rbit_dir_prefix/build/sources.list.udeb.local

# Modify boot menu
rm $rbit_dir_prefix/build/boot/x86/amdtxt.cfg
rm $rbit_dir_prefix/build/boot/x86/amdgtk.cfg
rm $rbit_dir_prefix/build/boot/x86/amdadtxt.cfg
rm $rbit_dir_prefix/build/boot/x86/amdadgtk.cfg
rm $rbit_dir_prefix/build/boot/x86/adgtk.cfg
rm $rbit_dir_prefix/build/boot/x86/xen/*
rmdir $rbit_dir_prefix/build/boot/x86/xen

#sed -i -e '/rescue/,$d' $rbit_dir_prefix/build/boot/x86/adtxt.cfg
rm $rbit_dir_prefix/build/boot/x86/adtxt.cfg

cp $MENU_CFG $rbit_dir_prefix/build/boot/x86/
cat >> $rbit_dir_prefix/build/boot/x86/adtxt.cfg << EOF
label rescue
        menu label ^Rescue mode
        kernel \${KERNEL}
        append \${VIDEO_MODE} initrd=\${INITRD} rescue/enable=true -- quiet \${CONSOLE}
EOF
#cat >> $rbit_dir_prefix/build/boot/x86/adgtk.cfg << EOF
#label expressgui
#	menu label Graphical express install
#	kernel ${KERNEL}
#	append ${VIDEO_MODE_GTK} initrd=${INITRD_GTK} preseed/file=/preseed-express.cfg -- ${CONSOLE}
#EOF

rm -rf $TMPD
echo "Всё. Теперь допишите список изменений с помощью команды dch --increment и можно собирать пакет."
